
#ifndef Game_Automaton_H
#define Game_Automaton_H

#include "TypeDef.h"

#include "Entity.h"
#include "Visual.h"
#include "Observe.h"
#include "Attack.h"
#include "Unit.h"

#include "Generator.h"



class base_Automaton
	: public I_Entity, public I_Visual,
	  public I_Observed, public I_Observer, public I_Attacked,
	  public I_Unit
{
public:
	base_Automaton(I_UnitController &controller,
				   Generator &generator,const Point &pos,RadianAngle dir,
				   const Vector & velocity,RadianAngle angle_v = 0)
	  : I_Entity(generator.Entity),
		I_Visual(generator.Visual,VL_Top),
		I_Observed(generator.Observed), I_Observer(generator.Observer),
		I_Attacked(generator.Attacked),
		Generator(generator),
		Velocity(velocity), AngleV(angle_v),
		Controller(&controller),
		Position(pos), Direction(dir)
	{}
	virtual ~base_Automaton(void) {}

//	virtual bool Update(void) = 0;
//	virtual void Visualize(const Visualizer &visualizer) const = 0;


	virtual const Point &position(void) const {return Position;}
	virtual RadianAngle direction(void) const {return Direction;}
	virtual const Vector &velocity(void) const {return Velocity;}

//	virtual void Observe(ObserveParam &param) = 0;

//	virtual void Damaged(uint32 power,const Vector &vector,const I_Attacker &attacker) = 0;

//	virtual const I_Shape &attackedShape(void) const = 0;

//	virtual void Move(RadianAngle direction) = 0;
//	virtual void Turn(RadianAngle direction) = 0;
//	virtual void Act(unsigned int command) = 0;

//	virtual float damageRate(void) const = 0;


protected:
	Generator &Generator;
	Vector Velocity;
	RadianAngle AngleV;

	void UpdatePosition(void)
	{
		Position += Velocity;
		Direction += AngleV;
	}
	I_UnitController *Controller;
private:
	Point Position;
	RadianAngle Direction;
};

#endif
