
#ifndef Game_Enemy_H
#define Game_Enemy_H

#include "Automaton.h"


class Enemy : public base_Automaton, public Juna::D2::Intersection::I_Circle
{
	Enemy(::Generator &generator,int32 life_counter,
		  const Point &position,RadianAngle direction,const Vector & velocity)
		  : base_Automaton(DefController,generator,position,direction,velocity),
		    LifeCounter(life_counter)
	{}
	~Enemy() {}
public:
	static Enemy *Create(::Generator &generator,int32 life_counter,
						 const Point &position,RadianAngle direction,const Vector & velocity);

	virtual bool Update(void);
	virtual void Break(void);
	virtual void Visualize(const VisualizeParam &param) const;


	virtual void Observe(const ObserveParam &param);

	virtual const I_Shape &attackedShape(void) const {return *this;}

	virtual void Damaged(uint32 power,const Vector &vector,
						 const I_Attacker &attacker);

	virtual void Move(RadianAngle direction);
	virtual void Turn(RadianAngle direction);
	virtual void Act(unsigned int command);

//	virtual float damageRate(void) const;

//	virtual void Attack(const AttackParam &param);

private:
	int32 LifeCounter;

	class DefController : public I_UnitController
	{
	public:
		DefController(void) : ActionCounter(0) {}
		virtual void UnitControl(I_Unit &controlled,const ObserveParam &observed);
		uint32 ActionCounter;
	};
	DefController DefController;
	virtual Data GetCircleData(void) const {return Data(position(),8);}
};

#endif
