
#ifndef Game_Entity_H
#define Game_Entity_H

#include "Juna/intrusive_list.hpp"

class I_Entity;
class I_EntityCreator;

class EntityManager;

typedef Juna::intrusive_list<I_Entity> EntityList;


class I_Entity : public Juna::intrusive_list_node
{
	friend class EntityManager;
private:
//	Ԃ̍XVBȂfalseԂB
	virtual bool Update(void) = 0;
//	łB
	virtual void Break(void) = 0;
protected:
	I_Entity(I_EntityCreator &creator);
	~I_Entity() {}
private:
	using Juna::intrusive_list_node::unlink;
};

class I_EntityCreator
{
private: friend class I_Entity;
	void Create(I_Entity &entity) {Creature.push_back(entity);}
private: friend class EntityManager;
	EntityList Creature;
};

inline I_Entity::I_Entity(I_EntityCreator &creator) {creator.Create(*this);}

class EntityManager
{
public:
	void UpdatePhase(void)
	{
		for (EntityList::iterator it = Entity.begin();it != Entity.end();)
		{
			if (!it->Update())
			{
				I_Entity *e = &*it;
				it = Entity.erase(it);
				e->Break();
			}
			else
				++it;
		}
	}
	void RealizeCreature(void)
	{
		Entity.splice(Entity.end(),Creator.Creature);
	}

	void Clear(void)
	{
		for (EntityList::iterator it = Entity.begin();it != Entity.end();)
		{
			I_Entity *e = &*it;
			it = Entity.erase(it);
			e->Break();
		}
	}


private:
	EntityList Entity;
public:
	I_EntityCreator Creator;
};

#endif
