
#include "GameDefine.h"
#include "Game.h"

#include <stdlib.h>

#include "Juna/Picture/BitmapFile.h"
#include "Juna/D2D/D2D_Picture.h"
#include "Juna/D2D/D2D_Blit.h"
#include "Juna/D2D/D2D_Font.h"

using namespace Juna;

Game::Game(void)
  : Graphics(),Sound(),Input(),
	CurrentScene(0), Title()
{}

bool Game::Initialize(void)
{
	if (!Graphics.Initialize(false))
		return false;
	if (!Sound.Initialize())
		return false;

	if (!Input.Keyboard.Initialize())
		goto ERR;
	Input.Pad.Initialize();

	if (!Shooting.Initialize(Graphics.Manager.backBuffer(),
							 Graphics.Sprite,Graphics.ASCII,Graphics.BG,
							 Input.Pad))
		return false;

	if (!Title.Initialize(Graphics.Manager.backBuffer(),Graphics.Sprite,Graphics.ASCII,Input.Pad,Shooting))
		return false;

	CurrentScene = &Title;
	return true;

ERR:;
	Terminalize();
	return false;
}

void Game::Terminalize(void)
{
	Shooting.Terminalize();
	Input.Terminalize();
	Sound.Terminalize();

//	Picture::Image image;
//	SavePictureImage(image,Graphics.Manager.backBuffer());
//	SaveBitmapFile("test_back.bmp",image,false,true);

	Graphics.Terminalize();

	CurrentScene = 0;
}



bool Game::ProcessFrame(void)
{
	Input.GetInput();


//	SceneManager.Action();

//	DrawFPS();

	D2D::I_ScreenSurface &bb = Graphics.Manager.backBuffer();
	bb.Clear();
	bb.BeginBlit();

	CurrentScene = CurrentScene->Action();
	if (!CurrentScene)
		return false;

	bb.EndBlit();
	Graphics.Manager.Flip();
	return true;
}

void Game::Activate(bool activate)
{
	if (activate)
	{
	}
	else
	{
	}
}
void Game::NonActivePaint(void)
{
	D2D::Manager &manager = Graphics.Manager;
	if (manager.GetD3DDevice() && !manager.isFullScreen())
	{
		manager.Flip();
	}
}

bool Game::ScreenChange(void)
{
	return Graphics.ChangeScreen(!Graphics.isFullScreen());
}
