
#ifndef GAME_H
#define GAME_H

#include "Graphics.h"
#include "SoundManager.h"
#include "InputManager.h"

#include "ShootingScene.h"
#include "TitleScene.h"

class Game
{
protected:
	Game(void);

	bool Initialize(void);
	bool ProcessFrame(void);
	void Terminalize(void);


	static const char *GetWindowNameA(void) {return "Untitled X";}
	static const wchar_t *GetWindowNameW(void) {return L"Untitled X";}
	static unsigned int GetFrameRate(void) {return 60;}

	void Activate(bool);
	void NonActivePaint(void);
	bool ScreenChange(void);


private:
	GraphicsManager Graphics;
	SoundManager Sound;
	InputManager Input;

	I_Scene *CurrentScene;
	ShootingScene Shooting;
	TitleScene Title;
};

#endif
