
#ifndef Game_Object_Generator_H
#define Game_Object_Generator_H


class I_EntityCreator;

class I_VisualCreator;

class I_AttackedCreator;
class I_AttackerCreator;

class I_ObservedCreator;
class I_ObserverCreator;

class I_ObstructedCreator;
class I_ObstructorCreator;

class I_Allocator;

class Generator
{
public:
	I_EntityCreator &Entity;
	I_VisualCreator &Visual;

	I_AttackedCreator &Attacked;
	I_AttackerCreator &Attacker;

	I_ObservedCreator &Observed;
	I_ObserverCreator &Observer;

	I_ObstructedCreator &Obstructed;
	I_ObstructorCreator &Obstructor;

	I_Allocator &Allocator;

	Generator(I_EntityCreator &entity,I_VisualCreator &visual,
			  I_AttackedCreator &attacked,I_AttackerCreator &attacker,
			  I_ObservedCreator &observed,I_ObserverCreator &observer,
			  I_ObstructedCreator &obstructed,I_ObstructorCreator &obstructor,
			  I_Allocator &allocator)
	  : Entity(entity), Visual(visual),
		Attacked(attacked), Attacker(attacker),
		Observed(observed), Observer(observer),
		Obstructed(obstructed),Obstructor(obstructor),
		Allocator(allocator)
	{}
private:
	void operator=(Generator &);
};

#endif
