
#include "Graphics.h"
#include "GameDefine.h"

#include "Juna/D2D/D2D_Picture.h"
#include "Juna/Picture/BitmapFile.h"

#include "PNG_File.h"

bool GraphicsManager::Initialize(bool fullscreen)
{
	if (!Manager.Initialize(ScreenWidth,ScreenHeight,fullscreen,32,60))
		return false;
	Manager.SetLinearFilter(true);

	if (!Sprite.Initialize(Manager,256,256))
		goto ERR;
	if (!ASCII.Initialize(Manager,256,128))
		goto ERR;
	if (!BG.Initialize(Manager,480,480))
		goto ERR;

	{
		using namespace Juna;
		Picture::Image image;
		if (!InitLoadPNGFile(image,"bmp\\sprite.png"))
			goto ERR;
//		if (!Picture::InitLoadBitmapFile(image,"bmp\\sprite.bmp"))
//			goto ERR;
		if (!D2D::LoadPictureImage(Sprite,image))
			goto ERR;
		if (!InitLoadPNGFile(image,"bmp\\ascii.png"))
			goto ERR;
//		if (!Picture::InitLoadBitmapFile(image,"bmp\\ascii.bmp"))
//			goto ERR;
		if (!D2D::LoadPictureImage(ASCII,image))
			goto ERR;

		{
			if (!InitLoadPNGFile(image,"bmp\\bg.png"))
				goto ERR;
			D2D::SpriteSurface ss;
			if (!ss.Initialize(Manager,image.width(),image.height()))
				goto ERR;
			if (!D2D::LoadPictureImage(ss,image))
				goto ERR;
			BG.BeginBlit();
			BG.Clear();
//			BG.Blit(240,240,ss,D2D::FRect(0,0,ss.width(),ss.height()),0,2.0,2.0);
			BG.Blit(0,0,ss,D2D::Rect(0,0,ss.width(),ss.height()),2.0,2.0);
			BG.EndBlit();
		}
	}

	return true;

ERR:;
	Terminalize();
	return false;
}
void GraphicsManager::Terminalize(void)
{
	BG.Terminalize();
	ASCII.Terminalize();
	Sprite.Terminalize();
	Manager.Terminalize();
}

bool GraphicsManager::ChangeScreen(bool fullscreen)
{
	if (!Manager.ResetScreenMode(fullscreen,32,60))
		return false;
	Manager.SetLinearFilter(true);
	return true;
}


/*
		if (!Picture::InitLoadBitmapFile(image,"bmp\\char.bmp"))
			goto ERR;
//		Picture::SetAlphaFromBrightness(image);
		if (!Graphics.ASCII_Char.Initialize(manager,image.width(),image.height()))
			goto ERR;
		if (!D2D::LoadPictureImage(Graphics.ASCII_Char,image))
			goto ERR;

void DrawManager::DrawASCIIString(D2D::I_ScreenSurface &target,
								  int x,int y,const char *string)
{
	for (const char *c = string;*c != '\0';c++)
	{
		Rect crect((*c & 15) * 16,((*c - ' ') / 16) * 16,Size(16,16));
		target.Blit(x + int(c - string) * 16,y,ASCII_Char,crect);
	}
}

void DrawManager::DrawNumber(D2D::I_ScreenSurface &target,
							 int x,int y,unsigned num,unsigned figure,bool fillzero)
{
	int div_table[9] = {1,10,100,1000,10000,100000,1000000,10000000,100000000};
	int div = div_table[figure - 1];

	unsigned i = 0;
	if (!fillzero)
	{
		for (;i < figure - 1;i++)
		{
			if ((num / div) % 10 != 0)
				break;
			div /= 10;
		}
	}
	for (;i < figure;i++)
	{
		int n = (num / div) % 10;
		div /= 10;
		Rect crect(n * 16,16,Size(16,16));
		target.Blit(x + i * 16,y,ASCII_Char,crect);
	}
}
*/