#define INITGUID
#include <dinput.h>
#pragma comment(lib,"dinput8.lib")

#pragma comment(lib,"winmm.lib")

#include "Input.h"

namespace {
HWND SearchMyWindow(void)
{
	HWND hwnd = NULL;
	{	//EnumThreadWindowsŒT
		struct local {
			static BOOL CALLBACK ETWP(HWND hwnd,LPARAM lParam)
				{(*(HWND *)lParam) = hwnd;return FALSE;}
		};
		::EnumThreadWindows(GetCurrentThreadId(),local::ETWP,(LPARAM)&hwnd);
	}
	if (hwnd == NULL)
	{	//EnumWindows + GetWindowThreadProcessIdŒT
		struct local
		{
			static BOOL CALLBACK EWP(HWND hwnd,LPARAM lParam)
			{
				DWORD wpid;
				::GetWindowThreadProcessId(hwnd,&wpid);
				if (wpid == ::GetCurrentProcessId()) {
					(*(HWND *)lParam) = hwnd;
					return FALSE;
				}
				return TRUE;
			}
		};
		::EnumWindows(local::EWP,(LPARAM)&hwnd);
	}
	return hwnd;
}
}//	anonymous namespace


namespace Juna {
namespace Input {



APIGameController::APIGameController(unsigned int id)
{
	Reset(id);
}

void APIGameController::Reset(unsigned int id)
{
	ClearInput();
	JoyID = id;
	JOYCAPS jc;
	::joyGetDevCaps(JoyID,&jc,sizeof(jc));
	ButtonNum = min(jc.wNumButtons,32);
	X_center = (jc.wXmax + jc.wXmin) / 2;
	X_range = float(jc.wXmax - jc.wXmin) / 2;
	Y_center = (jc.wYmax + jc.wYmin) / 2;
	Y_range = float(jc.wYmax - jc.wYmin) / 2;
}
/*
void APIGameController::SetJoyXCenterRange(int percent)
{
	JOYCAPS jc;
	::joyGetDevCaps(JoyID,&jc,sizeof(jc));
	UINT xcenter = (jc.wXmax + jc.wXmin) / 2;
	UINT xrange = (jc.wXmax - jc.wXmin) / 2;
	LeftX = xcenter - xrange * percent / 100;
	RightX = xcenter + xrange * percent / 100;
}
void APIGameController::SetJoyYCenterRange(int percent)
{
	JOYCAPS jc;
	::joyGetDevCaps(JoyID,&jc,sizeof(jc));
	UINT ycenter = (jc.wYmax + jc.wYmin) / 2;
	UINT yrange = (jc.wYmax - jc.wYmin) / 2;
	UpY = ycenter - yrange * percent / 100;
	DownY = ycenter + yrange * percent / 100;
}
*/
//͏ԂXV܂
bool APIGameController::GetInput(void)
{
	JOYINFOEX jie = {sizeof(jie),JOY_RETURNBUTTONS | JOY_RETURNX | JOY_RETURNY};
	::joyGetPosEx(JoyID,&jie);
	X_axis = (jie.dwXpos - X_center) / X_range;
	Y_axis = (jie.dwYpos - Y_center) / Y_range;

	::memcpy(LastButton,Button,sizeof(bool) * ButtonNum);
	for (unsigned i = 0;i < ButtonNum;i++)
	{
		Button[i] = (jie.dwButtons & (1 << i)) != 0;
	}
	return true;
}
void APIGameController::CancelInput(void)
{
	::memcpy(Button,LastButton,sizeof(bool) * ButtonNum);
}


namespace {

class DirectInputObject
{
public:
	static IDirectInput8 *GetDIObject(void)
	{
		static DirectInputObject instance;
		return instance.Object;
	}
	~DirectInputObject()
	{
		if (Object)
			Object->Release();
	}
private:
	DirectInputObject(void) : Object(0)
	{
		if FAILED(::DirectInput8Create(GetModuleHandle(NULL),
				DIRECTINPUT_VERSION,IID_IDirectInput8,
				reinterpret_cast<void **>(&Object),NULL))
		{
			Object = 0;
		}
	}
	IDirectInput8 *Object;
};

}//namespace ""



Keyboard::Keyboard(void) : Device(0)
{
	for (int i = 0;i< 256;i++) KeyState[i] = LastKeyState[i] = 0;
}
Keyboard::~Keyboard() {Terminalize();}

bool Keyboard::GetInput(void)
{
	HRESULT dir;

//L[{[h
	::memcpy(LastKeyState,KeyState,sizeof(unsigned char) * 256);
	dir = Device->GetDeviceState(256,(void *)KeyState);
	if FAILED(dir)
	{
		if (dir == DIERR_INPUTLOST || dir == DIERR_NOTACQUIRED)
		{
			dir = Device->Acquire();
			if SUCCEEDED(dir)
				dir = Device->GetDeviceState(256,(void *)KeyState);
			if FAILED(dir)
				return false;
		}
		else
			return false;
	}
	return true;
}
void Keyboard::CancelInput(void)
{
	::memcpy(KeyState,LastKeyState,sizeof(unsigned char) * 256);
}

bool Keyboard::Initialize(void)
{
	HWND hwnd = SearchMyWindow();
	if (hwnd == NULL)
		return false;
	IDirectInput8 *Object = DirectInputObject::GetDIObject();
	if FAILED(Object->CreateDevice(GUID_SysKeyboard,&Device,NULL))
		return false;
	if FAILED(Device->SetDataFormat(&c_dfDIKeyboard))
		goto ERR;

	if FAILED(Device->SetCooperativeLevel(hwnd,DISCL_FOREGROUND | DISCL_NONEXCLUSIVE))
//	if FAILED(Device->SetCooperativeLevel(hwnd,DISCL_BACKGROUND | DISCL_NONEXCLUSIVE))
		goto ERR;
	if FAILED(Device->Acquire())
		goto ERR;

	return true;
ERR:;
	Terminalize();
	return false;
}
void Keyboard::Terminalize(void)
{
	if (Device)
	{
		Device->Unacquire();
		Device->Release();
		Device = 0;
	}
}

DIGameController::DIGameController(void) : Device(0),ButtonNum(0) {ClearInput();}

DIGameController::~DIGameController() {Terminalize();}


//͏ԂXV܂
bool DIGameController::GetInput(void)
{
	HRESULT dir;
	DIJOYSTATE dijs = {0};
	if (Device)
	{
		if (FAILED(dir = Device->Poll()) ||
			FAILED(dir = Device->GetDeviceState(sizeof(dijs),&dijs)))
		{
			if (dir == DIERR_INPUTLOST || dir == DIERR_NOTACQUIRED)
			{
				if (FAILED(dir = Device->Acquire()) ||
					FAILED(dir = Device->Poll()) ||
					FAILED(dir = Device->GetDeviceState(sizeof(dijs),&dijs)))
					return false;
			}
			else
				return false;
		}
	}
	X_axis = (dijs.lX - X_center) / X_range;
	Y_axis = (dijs.lY - Y_center) / Y_range;

	::memcpy(LastButton,Button,sizeof(bool) * ButtonNum);
	for (unsigned i = 0;i < ButtonNum;i++)
	{
		Button[i] = dijs.rgbButtons[i] != 0;
	}

	return true;
}
void DIGameController::CancelInput(void)
{
	::memcpy(Button,LastButton,sizeof(bool) * ButtonNum);
}


namespace {

struct CallBackParam
{
	IDirectInput8 *dio;
	HWND hwnd;
	int id;
	IDirectInputDevice8 *joy;
};

BOOL CALLBACK EnumJoy(LPCDIDEVICEINSTANCE lpddi,LPVOID pvRef)
{
	CallBackParam * const cbp = static_cast<CallBackParam * const>(pvRef);
	IDirectInputDevice8 *testjoy = NULL;

	if FAILED(cbp->dio->CreateDevice(lpddi->guidInstance,&testjoy,NULL))
		return DIENUM_CONTINUE;

	DIPROPDWORD dipd = {sizeof(DIPROPDWORD),sizeof(DIPROPHEADER),0,DIPH_DEVICE};
	if FAILED(testjoy->GetProperty(DIPROP_JOYSTICKID,&dipd.diph))
		goto CONTINUE;

	if (cbp->id >= 0 && static_cast<unsigned long>(cbp->id) != dipd.dwData)
		goto CONTINUE;

	if FAILED(testjoy->SetDataFormat(&::c_dfDIJoystick))
		goto ERR;

//	if FAILED(testjoy->SetCooperativeLevel(cbp->hwnd,DISCL_FOREGROUND | DISCL_NONEXCLUSIVE))
	if FAILED(testjoy->SetCooperativeLevel(cbp->hwnd,DISCL_BACKGROUND | DISCL_NONEXCLUSIVE))
		goto ERR;
	if FAILED(testjoy->Acquire())
		goto ERR;
	cbp->joy = testjoy;
	return DIENUM_STOP;

CONTINUE:;
	testjoy->Release();
	return DIENUM_CONTINUE;
ERR:;
	testjoy->Release();
	return (cbp->id < 0) ? DIENUM_CONTINUE : DIENUM_STOP;
}

}//namespace ""

bool DIGameController::Initialize(int id)
{
	Terminalize();
	HWND hwnd = SearchMyWindow();
	if (hwnd == NULL)
		return false;
	IDirectInput8 *Object = DirectInputObject::GetDIObject();
	CallBackParam cbp = {Object,hwnd,id};
	Object->EnumDevices(DI8DEVCLASS_GAMECTRL,EnumJoy,&cbp,DIEDFL_ATTACHEDONLY);
	Device = cbp.joy;
	if (Device)
	{
		DIDEVCAPS didc = {sizeof(didc)};
		if FAILED(Device->GetCapabilities(&didc))
			goto ERR;
		ButtonNum = min(didc.dwButtons,32);

		DIPROPRANGE dipr;
		dipr.diph.dwSize = sizeof(DIPROPRANGE);
		dipr.diph.dwHeaderSize	= sizeof(DIPROPHEADER);
		dipr.diph.dwHow = DIPH_BYOFFSET;
		dipr.diph.dwObj = DIJOFS_X;
		if FAILED(Device->GetProperty(DIPROP_RANGE,&dipr.diph))
			goto ERR;
		X_center = (dipr.lMax + dipr.lMin) / 2;
		X_range = float(dipr.lMax - dipr.lMin) / 2;
		dipr.diph.dwObj = DIJOFS_Y;
		if FAILED(Device->GetProperty(DIPROP_RANGE,&dipr.diph))
			goto ERR;
		Y_center = (dipr.lMax + dipr.lMin) / 2;
		Y_range = float(dipr.lMax - dipr.lMin) / 2;

		return true;
	}
	return false;
ERR:;
	Terminalize();
	return false;
}

void DIGameController::Terminalize(void)
{
	if (Device)
	{
		Device->Unacquire();
		Device->Release();
		Device = NULL;
	}
}

//ANZX̎擾
bool DIGameController::Acquire(void)
{
	if (Device)
	{
		if FAILED(Device->Acquire())
			return false;
		Device->Poll();
	}
	return true;
}
bool DIGameController::UnAcquire(void)
{
	if (Device)
	{
		Device->Poll();
		if FAILED(Device->Unacquire())
			return false;
	}
	return true;
}
/*
//݉ĂL[{[hL[DIK萔Ԃ
int Keyboard::GetDIKeyIndex(void)
{
	HRESULT dir;
	unsigned char key[256];
	dir = Keyboard->GetDeviceState(256,(void *)key);
	if (dir != DI_OK)
	{
		if (dir == DIERR_INPUTLOST)
		{
			dir = Keyboard->Acquire();
			if (dir == DI_OK || dir == S_FALSE)
			{
				dir = Keyboard->GetDeviceState(256,(void *)key);
			}
			if (dir != DI_OK)
			{
				return -1;
			}
		}
		else
		{
			return -1;
		}
	}

	int i;
	for (i = 0;i < 256;i++)
	{
		if (key[i])
			return i;
	}

	return 0;
}
*/

}//namespace Juna
}//namespace Input

