
#include "../D2D_SpriteScreenSurface.h"


namespace Juna {
namespace D2D {
	
bool I_SpriteScreenSurface::Initialize(D2D::Manager &manager,int width,int height)
{
	Terminalize();
	if (!I_SpriteSurface::Initialize(manager,width,height,32,VRAM,true))
		return false;
	I_ScreenSurface::Manager = I_SpriteSurface::Manager;
	I_ScreenSurface::Width = I_SpriteSurface::Width;
	I_ScreenSurface::Height = I_SpriteSurface::Height;
	I_ScreenSurface::Surface = I_SpriteSurface::Surface;
	manager.EnterManaged(*this);
	return true;
}
void I_SpriteScreenSurface::Terminalize(void)
{
	if (isManaged())
		I_SpriteSurface::Manager->ExitManaged(*this);
	I_SpriteSurface::Terminalize();
	I_ScreenSurface::Terminalize();
}
void I_SpriteScreenSurface::Release(void)
{
	I_ScreenSurface::Release();
	I_SpriteSurface::Release();
}
bool I_SpriteScreenSurface::Restore(void)
{
	if (!I_SpriteSurface::Restore(32,VRAM,true))
		return false;
	I_ScreenSurface::Surface = I_SpriteSurface::Surface;
	return true;
}

bool SpriteScreenSurface::Initialize(D2D::Manager &manager,int width,int height)
{
	return I_SpriteScreenSurface::Initialize(manager,width,height);
}
void SpriteScreenSurface::Terminalize(void) {I_SpriteScreenSurface::Terminalize();}

bool SpriteScreenSurface2::Initialize(D2D::Manager &manager,int width,int height)
{
	Terminalize();
	if (!I_SpriteScreenSurface::Initialize(manager,width,height))
		return false;

	if (!Backup.Initialize(GetSurface())) {
		I_SpriteScreenSurface::Terminalize();
		return false;
	}
	return true;
}
void SpriteScreenSurface2::Terminalize(void)
{
	Backup.Terminalize();
	I_SpriteScreenSurface::Terminalize();
}

bool SpriteScreenSurface2::SaveImage(const Rect *rect)
{
	if (rect)
		return Backup.Copy(rect->x1,rect->y1,GetSurface(),rect);
	else
		return Backup.Copy(0,0,GetSurface(),0);
}
bool SpriteScreenSurface2::RestoreImage(const Rect *rect)
{
	if (rect)
		return GetSurface().Copy(rect->x1,rect->y1,Backup,rect);
	else
		return GetSurface().Copy(0,0,Backup,0);
}
bool SpriteScreenSurface2::Restore(void)
{
	if (!I_SpriteScreenSurface::Restore())
		return false;
	return RestoreImage();
}


}//namespace D2D
}//namespace Juna

