
#ifndef Juna_Sound_Format_H
#define Juna_Sound_Format_H


namespace Juna {
namespace Sound {

typedef unsigned char	byte;
typedef unsigned short	uint16;
typedef unsigned long	uint32;


//ʎq̎
enum QuantizationType {
	QT_NULL = 0,	//ȏ
	QT_SIGNED,		//t
	QT_UNSIGNED,	//
	QT_FLOAT,		//IEEE_
};

//tH[}bg\
struct Format
{
	uint32	frequency;		//TvOg
	uint16	bit;			//ʎqrbg
	byte	channel;		//`l
	byte	quantization;	//QuantizationType ʎq̎

//ȉ֗֐

	//bit̃oCgTCY
	int bit_size(void) const {return (bit + 7) / 8;}
	//1TṽTCY
	int sample_size(void) const {return bit_size() * channel;}

	Format(void) {reset();}
	Format(uint32 f,uint16 b,byte c,QuantizationType q) {set(f,b,c,q);}
	Format(uint32 f,uint16 b,byte c) {set(f,b,c);}

	void reset(void) {frequency = 0;bit = 0;channel = 0;quantization = QT_NULL;}
	void set(uint32 f,uint16 b,byte c,QuantizationType q) {frequency = f;bit = b;channel = c;quantization = byte(q);}
	void set(uint32 f,uint16 b,byte c)
	{
		frequency = f;bit = b;channel = c;
		switch (bit)
		{
		case  8:quantization = QT_UNSIGNED;break;
		case 16:case 24:quantization = QT_SIGNED;break;
		case 32:case 64:quantization = QT_FLOAT;break;
		default:quantization = QT_NULL;
		}
	}

	bool operator==(const Format &rhs) const
	{
		if (frequency == rhs.frequency && bit == rhs.bit && channel == rhs.channel &&
			quantization == rhs.quantization)
			return true;
		return false;
	}
	bool operator!=(const Format &rhs) const {return !(*this == rhs);}
};


}//namespace Sound
}//namespace Juna


#endif
