
#ifndef JunaSound_Player_H
#define JunaSound_Player_H

#include "InputStream.h"

namespace Juna {
namespace Sound {

class VolumeControler
{
protected:
public:
//fVxŃ{[ݒ max = 0.0
	virtual bool SetVolume_dB(double iVol) = 0;
	virtual double GetVolume_dB(void) const = 0;

//jAŃ{[ݒ max = 0x100,min = 0x00
	virtual bool SetVolume(unsigned iVol) = 0;
	virtual unsigned GetVolume(void) const = 0;

};
class PanControler
{
protected:
public:
//fVxŃpݒ left = min(0.0,-iPan) right = min(0.0,iPan)
	virtual bool SetPan_dB(double iPan) = 0;
	virtual double GetPan_dB(void) const = 0;

//jAŃpݒ
	virtual bool SetPan(long iPan) = 0;
	virtual long GetPan(void) const = 0;

};

class I_PlayDriver;	//O錾

class I_Player
{
protected:
	~I_Player() {}
public:
//ĐJn܂B
	virtual bool Start(void) = 0;
//Đ~܂B
	virtual bool Stop(void) = 0;
//ĐǂB
	virtual bool isPlaying(void) const = 0;

//ĐtH[}bg擾܂B
	virtual Format GetFormat(void) const = 0;

//hCõC^[tFCX̃|C^(ID)擾܂B
	virtual const I_PlayDriver *GetDriver(void) = 0;
};

//Xg[~OĐC^[tFCX
class I_StreamPlayer : public I_Player
{
protected:
	~I_StreamPlayer() {}
public:
//I_Player interface
	virtual bool Start(void) = 0;
	virtual bool Stop(void) = 0;
	virtual bool isPlaying(void) const = 0;
	virtual Format GetFormat(void) const = 0;
	virtual const I_PlayDriver *GetDriver(void) = 0;

/*
	Đf[^̓Xg[ݒ肵܂B
	Ƃ̃Xg[AddRef()ĂяoA
	܂Őݒ肳ĂXg[Release()ĂяoB
	0ݒ肷ƏԂɖ߂B
*/
	virtual bool SetSupplier(I_InputStream *setStream) = 0;

//ĐԂTvPʂŎ擾܂Bs-1
	virtual long GetPlayTime(void) = 0;

//ۂɐݒ肳ꂽobt@TCY擾܂B
	virtual void GetBufferSize(unsigned long &oBufsize,int &oBufnum) const = 0;


//SetSupplier()ɂĐݒ肳ꂽ͂sA
//SɍĐĎIɒ~ԂɂȂɌĂ΂֐ݒ肷B
	class I_PlayEndCallback
	{
	protected: ~I_PlayEndCallback() {}
	public: virtual void PlayEndCallback(void) = 0;
	};
	virtual void SetPlayEndCallback(I_PlayEndCallback *setCallback) = 0;


//ݒ肳ꂽf[^蓮Ńobt@ɏ݂܂
// 0 = I
// 1 = obt@^ŏ߂Ȃ
// 2 = f[^̏I[ɒBAǂݍ
// -1 = 炩̃G[
//ĐOɔCӂ̃^C~OŃf[^[ĥɎg܂B
//}`XbhɑΉĂȂ̂ŁAĐɌĂяoĂ͂܂B
	virtual int LoadStream(void) = 0;
};



//Œobt@ĐC^[tFCX
//(stream)ɑ΂Đ܂(pool)
class I_PoolPlayer : public I_Player
{
protected:
	~I_PoolPlayer() {}
public:
//I_Player interface
	virtual bool Start(void) = 0;
	virtual bool Stop(void) = 0;
	virtual bool isPlaying(void) const = 0;
	virtual Format GetFormat(void) const = 0;
	virtual const I_PlayDriver *GetDriver(void) = 0;


//[vݒ
	virtual void SetLoopFlag(bool loop) = 0;
	virtual bool GetLoopFlag(void) const = 0;

//ĐʒuTvPʂŎ擾܂Bs-1
	virtual long GetPlayPosition(void) = 0;

//ݒ肳ꂽobt@TCY擾܂B
	virtual unsigned long GetBufferSize(void) const = 0;

//obt@Ƀf[^ǂݍ
	virtual bool LoadStream(I_InputStream &ioStream) = 0;
//Xg[݂̌̈ʒuobt@tɂȂ܂œǂݍ݂܂B
//rŃXg[̏I[ɒBꍇAc͖Ŗ߂܂B
};



//ĐfoCX\
struct PlayDeviceData {char *name;};
//EChEYUNICODE(BOMUTF-16 LE?)
struct PlayDeviceDataW {wchar_t *name;};


//ĐC^[tFCXC^[tFCX
class I_PlayDriver
{
protected:
	~I_PlayDriver() {}
public:
//vC[C^[tFCX̐Ɣj

//Xg[~OvC[C^[tFCX
	virtual I_StreamPlayer *CreateStreamPlayer
		(int iDevice,								//ĐfoCXCfbNX
		 const Format &iFormat,						//tH[}bg
		 long iBufsize = 0,int iBufnum = 3) = 0;	//obt@TCY
//w肵Xg[ɂ킹Đ
	virtual I_StreamPlayer *CreateStreamPlayer
		(int iDevice,								//ĐfoCXCfbNX
		 I_InputStream &setStream,					//Xg[
		 long iBufsize = 0,int iBufnum = 3) = 0;	//obt@TCY

//ǂݍݍς݃obt@vC[C^[tFCX
	virtual I_PoolPlayer *CreatePoolPlayer
		(int iDevice,							//ĐfoCXCfbNX
		 const Format &iFormat,					//tH[}bg
		 long iBufSize) = 0;					//obt@TCY
//w肵f[^ɂ킹ăvC[𐶐
	virtual I_PoolPlayer *CreatePoolPlayer
		(int iDevice,							//ĐfoCXCfbNX
		 I_SeekableInputStream &ioStream) = 0;	//ǂݍރf[^
//ioStream̓ǂݍ݈ʒuɂ炸ASẴf[^ǂݍƂ܂

//PoolPlayerobt@Lĕ𐶐B
	virtual I_PoolPlayer *CreatePoolPlayer
		(I_PoolPlayer &iDuplicateSrc) = 0;		//

//vC[C^[tFCXj
	virtual void DestroyPlayer(I_StreamPlayer *player) = 0;
	virtual void DestroyPlayer(I_PoolPlayer *player) = 0;


public:
//foCX̎擾

//ĐfoCX̑
	virtual int GetDeviceNum(void) = 0;
//ĐfoCX̏
	virtual const PlayDeviceData *GetDeviceData(int index) = 0;
	virtual const PlayDeviceDataW *GetDeviceDataW(int index) = 0;
//w̃tH[}bgŃfoCXJ邩
	virtual bool TestOpenDevice(int index,const Format &format) = 0;

//foCXXgXV
	virtual void UpdateDeviceList(void) = 0;
	virtual void UpdateDeviceListW(void) = 0;
//foCXXg폜
	virtual void DeleteDeviceList(void) = 0;
};



int GetPlayDriverNum(void);
const char *GetPlayDriverNameA(int index);
const wchar_t *GetPlayDriverNameW(int index);
I_PlayDriver *GetPlayDriverInterface(int index);


}//namespace Sound
}//namespace Juna

#endif

