
#ifndef JunaSound_DirectSoundStreamPlayDriver_H
#define JunaSound_DirectSoundStreamPlayDriver_H

#include "WindowsPlayer.h"

#ifndef DIRECTSOUND_VERSION
#define DIRECTSOUND_VERSION 0x0500
#endif
#include <dsound.h>


namespace Juna {
namespace Sound {


class DirectSoundPlayDriver : public I_DirectSoundPlayDriver
{
	DirectSoundPlayDriver(void);
public:
	~DirectSoundPlayDriver();

	virtual I_StreamPlayer *CreateStreamPlayer
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 3);
	virtual I_StreamPlayer *CreateStreamPlayer
		(int iDevice,I_InputStream &setStream,long iBufsize = 0,int iBufnum = 3);

	virtual I_PoolPlayer *CreatePoolPlayer(int iDevice,const Format &iFormat,long iBufSize);
	virtual I_PoolPlayer *CreatePoolPlayer(int iDevice,I_SeekableInputStream &iStream);
	virtual I_PoolPlayer *CreatePoolPlayer(I_PoolPlayer &iDuplicateSrc);

	virtual void DestroyPlayer(I_StreamPlayer *player);
	virtual void DestroyPlayer(I_PoolPlayer *player);


	virtual int GetDeviceNum(void);
	virtual const PlayDeviceData *GetDeviceData(int index);
	virtual const PlayDeviceDataW *GetDeviceDataW(int index);
	virtual bool TestOpenDevice(int index,const Format &format);

	virtual void UpdateDeviceList(void);
	virtual void UpdateDeviceListW(void);
	virtual void DeleteDeviceList(void);


//
	virtual I_DirectSoundStreamPlayer *CreateDSStreamPlayer
		(int iDevice,const Format &iFormat,
		 long iBufsize = 0,int iBufnum = 3,int iFocus = 1);
	virtual I_DirectSoundStreamPlayer *CreateDSStreamPlayer
		(int iDevice,I_InputStream &setStream,
		 long iBufsize = 0,int iBufnum = 3,int iFocus = 1);

	virtual I_DirectSoundPoolPlayer *CreateDSPoolPlayer
		(int iDevice,const Format &iFormat,long iBufSize,int iFocus = 1);
	virtual I_DirectSoundPoolPlayer *CreateDSPoolPlayer
		(int iDevice,I_SeekableInputStream &iStream,int iFocus = 1);
	virtual I_DirectSoundPoolPlayer *CreateDSPoolPlayer
		(I_PoolPlayer &iDuplicateSrc);

	virtual const DSoundDeviceData *GetDSDeviceData(int index);
	virtual const DSoundDeviceDataW *GetDSDeviceDataW(int index);
	virtual const GUID *GetDSDeviceGUID(int index);


	static DirectSoundPlayDriver &GetInstance(void);



//private + friend ɂ邩Y񂾂ǁAŁB
	typedef HRESULT (WINAPI *typeDSCreate)(const GUID *,LPDIRECTSOUND *,LPUNKNOWN);
	const typeDSCreate GetDSCreateProc(void);

private:
	HINSTANCE LoadDll(void);
	void FreeDll(void);

	void InitDeviceNum(void);
	typedef HRESULT (WINAPI *typeDSEnumA)(LPDSENUMCALLBACKA,LPVOID);
	typedef HRESULT (WINAPI *typeDSEnumW)(LPDSENUMCALLBACKW,LPVOID);

	const typeDSEnumA GetEnumProcA(void);
	const typeDSEnumW GetEnumProcW(void);

	DSoundDeviceData *list;
	DSoundDeviceDataW *wlist;
	int IndexNum;
	HINSTANCE hDSdll;

private:
	DirectSoundPlayDriver(DirectSoundPlayDriver &);
	void operator=(const DirectSoundPlayDriver &);
};

}//namespace Sound
}//namespace Juna

#endif

