
#ifndef JunaSound_WindowsPlayer_H
#define JunaSound_WindowsPlayer_H

#include "../Player.h"

#include <windows.h>

namespace Juna {
namespace Sound {
#pragma pack(push, 8)

//
class I_waveOutStreamPlayer : public I_StreamPlayer
{
protected:
	~I_waveOutStreamPlayer() {};
public:
//I_Player interface
	virtual bool Start(void) = 0;
	virtual bool Stop(void) = 0;
	virtual bool isPlaying(void) const = 0;
	virtual Format GetFormat(void) const = 0;
	virtual const I_PlayDriver *GetDriver(void) = 0;

//I_StreamPlayer interface
	virtual bool SetSupplier(I_InputStream *setStream) = 0;
	virtual long GetPlayTime(void) = 0;
	virtual void GetBufferSize(unsigned long &oBufsize,int &oBufnum) const = 0;
	virtual int LoadStream(void) = 0;


/*=============================================================================
 waveOutpǉC^[tFCX
=============================================================================*/

//waveOut(Get/Set)Volume
	virtual bool SetDeviceVolume(unsigned long iLeft,unsigned long iRight) = 0;
	virtual bool GetDeviceVolume(unsigned long &oLeft,unsigned long &oRight) const = 0;
//obt@Pʂ̎̓{[
	virtual bool SetBufferVolume(unsigned long iLeft,unsigned long iRight) = 0;
	virtual bool GetBufferVolume(unsigned long &oLeft,unsigned long &oRight) const = 0;
//W(Set/Get)Volume()ŏ̂ǂg̑ItOQƁB
//Device : BufferVolumeFlag() = false
//Buffer : BufferVolumeFlag() = true
	virtual bool &BufferVolumeFlag(void) = 0;
};

class I_waveOutPoolPlayer : public I_PoolPlayer
{
protected:
	~I_waveOutPoolPlayer() {}
public:
//I_Player interface
	virtual bool Start(void) = 0;
	virtual bool Stop(void) = 0;
	virtual bool isPlaying(void) const = 0;
	virtual Format GetFormat(void) const = 0;
	virtual const I_PlayDriver *GetDriver(void) = 0;

//I_PoolPlayer interface
	virtual void SetLoopFlag(bool loop) = 0;
	virtual bool GetLoopFlag(void) const = 0;
	virtual long GetPlayPosition(void) = 0;
	virtual unsigned long GetBufferSize(void) const = 0;
	virtual bool LoadStream(I_InputStream &ioStream) = 0;

/*=============================================================================
 waveOutExVolumepǉC^[tFCX
=============================================================================*/

//waveOut(Get/Set)Volume
	virtual bool SetDeviceVolume(unsigned long iLeft,unsigned long iRight) = 0;
	virtual bool GetDeviceVolume(unsigned long &oLeft,unsigned long &oRight) const = 0;
//obt@Pʂ̎̓{[
	virtual bool SetBufferVolume(unsigned long iLeft,unsigned long iRight) = 0;
	virtual bool GetBufferVolume(unsigned long &oLeft,unsigned long &oRight) const = 0;
//W(Set/Get)Volume()ŏ̂ǂg̑ItOQƁB
//Device : BufferVolumeFlag() = false
//Buffer : BufferVolumeFlag() = true
	virtual bool &BufferVolumeFlag(void) = 0;
};


struct waveOutDeviceData : public PlayDeviceData {
	UINT ID;
	WAVEOUTCAPSA wocaps;
};
struct waveOutDeviceDataW : public PlayDeviceDataW {
	UINT ID;
	WAVEOUTCAPSW wocaps;
};

class I_waveOutPlayDriver : public I_PlayDriver
{
protected:
	~I_waveOutPlayDriver() {}

public:
	virtual I_waveOutStreamPlayer *CreateWOStreamPlayer
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 3) = 0;
	virtual I_waveOutStreamPlayer *CreateWOStreamPlayer
		(int iDevice,I_InputStream &setStream,long iBufsize = 0,int iBufnum = 3) = 0;

	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(int iDevice,const Format &iFormat,long iBufSize) = 0;
	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(int iDevice,I_SeekableInputStream &ioStream) = 0;
	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(I_PoolPlayer &iDuplicateSrc) = 0;


	virtual const waveOutDeviceData *GetWODeviceData(int iIndex) = 0;
	virtual const waveOutDeviceDataW *GetWODeviceDataW(int iIndex) = 0;

	virtual const UINT *GetWODeviceID(int iIndex) = 0;
};


//
class I_DirectSoundStreamPlayer : public I_StreamPlayer
{
protected:
	~I_DirectSoundStreamPlayer() {}
public:
//I_Player interface
	virtual bool Start(void) = 0;
	virtual bool Stop(void) = 0;
	virtual bool isPlaying(void) const = 0;
	virtual Format GetFormat(void) const = 0;
	virtual const I_PlayDriver *GetDriver(void) = 0;

//I_StreamPlayer interface
	virtual bool SetSupplier(I_InputStream *setStream) = 0;
	virtual long GetPlayTime(void) = 0;
	virtual void GetBufferSize(unsigned long &oBufsize,int &oBufnum) const = 0;
	virtual int LoadStream(void) = 0;

/*=============================================================================
 DirectSoundpǉC^[tFCX
=============================================================================*/

//_w{[ݒ ő = 1.0,ŏ = 0.00001
	virtual bool SetVolumef(float iLeft,float iRight) = 0;
	virtual bool GetVolumef(float &oLeft,float &oRight) const = 0;
//fVxŃ{[ݒ ő = 0 ŏ = -10000
	virtual bool SetVolume_dB(long iLeft,long iRight) = 0;
	virtual bool GetVolume_dB(long &oLeft,long &oRight) const = 0;
};

class I_DirectSoundPoolPlayer : public I_PoolPlayer
{
//I_Player interface
	virtual bool Start(void) = 0;
	virtual bool Stop(void) = 0;
	virtual bool isPlaying(void) const = 0;
	virtual Format GetFormat(void) const = 0;
	virtual const I_PlayDriver *GetDriver(void) = 0;

//I_PoolPlayer interface
	virtual void SetLoopFlag(bool loop) = 0;
	virtual bool GetLoopFlag(void) const = 0;
	virtual long GetPlayPosition(void) = 0;
	virtual unsigned long GetBufferSize(void) const = 0;
	virtual bool LoadStream(I_InputStream &ioStream) = 0;

/*=============================================================================
 DirectSoundpǉC^[tFCX
=============================================================================*/

	virtual bool SetPlayPosition(long iSamplePos) = 0;

//_w{[ݒ ő = 1.0,ŏ = 0.00001
	virtual bool SetVolumef(float iLeft,float iRight) = 0;
	virtual bool GetVolumef(float &oLeft,float &oRight) const = 0;
//fVxŃ{[ݒ ő = 0 ŏ = -10000
	virtual bool SetVolume_dB(long iLeft,long iRight) = 0;
	virtual bool GetVolume_dB(long &oLeft,long &oRight) const = 0;
};


struct DSoundDeviceData : public PlayDeviceData {
	char *Module;
	GUID guid;
};
struct DSoundDeviceDataW : public PlayDeviceDataW {
	wchar_t *Module;
	GUID guid;
};

class I_DirectSoundPlayDriver : public I_PlayDriver
{
protected:
	~I_DirectSoundPlayDriver() {}
public:
//
	virtual I_DirectSoundStreamPlayer *CreateDSStreamPlayer
		(int iDevice,const Format &iFormat,
		 long iBufsize = 0,int iBufnum = 3,int iFocus = 1) = 0;
	virtual I_DirectSoundStreamPlayer *CreateDSStreamPlayer
		(int iDevice,I_InputStream &setStream,
		 long iBufsize = 0,int iBufnum = 3,int iFocus = 1) = 0;

	virtual I_DirectSoundPoolPlayer *CreateDSPoolPlayer
		(int iDevice,const Format &iFormat,long iBufSize,int iFocus = 1) = 0;
	virtual I_DirectSoundPoolPlayer *CreateDSPoolPlayer
		(int iDevice,I_SeekableInputStream &iStream,int iFocus = 1) = 0;
	virtual I_DirectSoundPoolPlayer *CreateDSPoolPlayer
		(I_PoolPlayer &iDuplicateSrc) = 0;



	virtual const DSoundDeviceData *GetDSDeviceData(int iIndex) = 0;
	virtual const DSoundDeviceDataW *GetDSDeviceDataW(int iIndex) = 0;

	virtual const GUID *GetDSDeviceGUID(int iIndex) = 0;
};

I_waveOutPlayDriver *GetWaveOutPlayDriver(void);
I_DirectSoundPlayDriver *GetDirectSoundPlayDriver(void);
I_waveOutPlayDriver *GetWaveOutExVolumePlayDriver(void);

#pragma pack(pop)
}//namespace Sound
}//namespace Juna

#endif
