
#ifndef Juna_Integer_Type_Define_H
#define Juna_Integer_Type_Define_H

namespace Juna {

typedef   signed char  int8;
typedef unsigned char  uint8;
typedef   signed short int16;
typedef unsigned short uint16;
typedef   signed long  int32;
typedef unsigned long  uint32;

typedef   signed __int64 int64;
typedef unsigned __int64 uint64;


template<typename IntType> struct integer_traits;

template<> struct integer_traits<int8>
{
	typedef int8   type;
	typedef int8   signed_type;
	typedef uint8  unsigned_type;
	typedef int16  signed_double_type;
	typedef uint16 unsigned_double_type;
	typedef void   signed_half_type;
	typedef void   unsigned_half_type;
};
template<> struct integer_traits<uint8>
{
	typedef uint8  type;
	typedef int8   signed_type;
	typedef uint8  unsigned_type;
	typedef int16  signed_double_type;
	typedef uint16 unsigned_double_type;
	typedef void   signed_half_type;
	typedef void   unsigned_half_type;
};
template<> struct integer_traits<int16>
{
	typedef int16  type;
	typedef int16  signed_type;
	typedef uint16 unsigned_type;
	typedef int32  signed_double_type;
	typedef uint32 unsigned_double_type;
	typedef int8   signed_half_type;
	typedef uint8  unsigned_half_type;
};
template<> struct integer_traits<uint16>
{
	typedef uint16 type;
	typedef int16  signed_type;
	typedef uint16 unsigned_type;
	typedef int32  signed_double_type;
	typedef uint32 unsigned_double_type;
	typedef int8   signed_half_type;
	typedef uint8  unsigned_half_type;
};
template<> struct integer_traits<int32>
{
	typedef int32  type;
	typedef int32  signed_type;
	typedef uint32 unsigned_type;
	typedef int64  signed_double_type;
	typedef uint64 unsigned_double_type;
	typedef int16  signed_half_type;
	typedef uint16 unsigned_half_type;
};
template<> struct integer_traits<uint32>
{
	typedef uint32 type;
	typedef int32  signed_type;
	typedef uint32 unsigned_type;
	typedef int64  signed_double_type;
	typedef uint64 unsigned_double_type;
	typedef int16  signed_half_type;
	typedef uint16 unsigned_half_type;
};
template<> struct integer_traits<int64>
{
	typedef int64  type;
	typedef int64  signed_type;
	typedef uint64 unsigned_type;
	typedef void   signed_double_type;
	typedef void   unsigned_double_type;
	typedef int32  signed_half_type;
	typedef uint32 unsigned_half_type;
};
template<> struct integer_traits<uint64>
{
	typedef uint64 type;
	typedef int64  signed_type;
	typedef uint64 unsigned_type;
	typedef void   signed_double_type;
	typedef void   unsigned_double_type;
	typedef int32  signed_half_type;
	typedef uint32 unsigned_half_type;
};

}//	namespace Juna

#endif
