
/*!
	@file
	@brief N^oAXgRei

	
	- ReiɗvfXgOƂłB
	- vf̓Rs[\łȂĂ\ȂB
	- ŃmۑȂB
	- |C^̃Xg菭B

	- intrusive_list_nodepȂ΂ȂȂB
	- vf͕̂ʂ̈肵ꏊŊmۂȂ΂ȂȂB

	@author Juna
*/

#ifndef Juna_Intrusive_Linked_List_Hpp
#define Juna_Intrusive_Linked_List_Hpp


#include <stddef.h>
#include <iterator>
#include <assert.h>


//!	namespace Juna
namespace Juna {

//!	Xgvf̐N̊b
/*!
*/
class base_intrusive_list_node
{
protected:
//!	ftHgRXgN^
/*!
	@post linked() == false
*/
	base_intrusive_list_node(void) {next = prev = this;}
//!	fXgN^
/*!
	@pre assert(linked() == false)
*/
	~base_intrusive_list_node()
	{
		assert(!linked());	//q܂܏
	}

	//
//!	XgɌqĂ邩
/*!
	@retval true qĂ
	@retval false qĂȂ
*/
	bool linked(void) const {return next != this;}

//!	XgO
/*!
	XgɃXgOB
*/
	void unlink(void)
	{
		prev->next = next;
		next->prev = prev;
		next = prev = this;
	}
private:
//	this->next == &otherƂȂ悤ɌqB
/*	{Iɂǂ炩ڑ̏ԂŎgpB */
	void link_next(base_intrusive_list_node &other)
	{
		other.prev->next = next;
		next->prev = other.prev;
		other.prev = this;
		next = &other;
	}
//	ւ
/*	otherƃNiʒujւB */
	void swap(base_intrusive_list_node &other)
	{
		base_intrusive_list_node *this_next = this->next;
		base_intrusive_list_node *this_prev = this->prev;
		base_intrusive_list_node *other_next = other.next;
		base_intrusive_list_node *other_prev = other.prev;

		this_prev->next = this_next->prev = &other;
		other_prev->next = other_next->prev = this;

		base_intrusive_list_node *next = this->next;
		base_intrusive_list_node *prev = this->prev;
		this->next = other.next;
		this->prev = other.prev;
		other.next = next;
		other.prev = prev;
	}
private:
friend class base_intrusive_list;

	base_intrusive_list_node *next;
	base_intrusive_list_node *prev;

private:
	base_intrusive_list_node(base_intrusive_list_node &);
	void operator=(base_intrusive_list_node &);
};

//!	Xgvf̐N
/*!
	p邱ƂŃXg̗vfƂȂ邱ƂłB
	ev[ǵAvf̃Xgɓo^ꍇɗpB
*/
template<int TagNumber>
class intrusive_list_node_ : public base_intrusive_list_node {};

//!	Xgvf̐N
/*!
	P̗vf̂߂̕ʖ
*/
typedef intrusive_list_node_<0> intrusive_list_node;

/*===========================================================================*/


//	N^oXgReiNX̋ʕ
//	base_intrusive_list_nodefriend
class base_intrusive_list
{
protected:
	typedef base_intrusive_list_node ilist_node;
	typedef size_t size_type;

	base_intrusive_list(void) : header() {}
	~base_intrusive_list() {}

	void clear(void);

	static ilist_node *insert(ilist_node *pos,ilist_node *ins);
	static ilist_node *insert_after(ilist_node *pos,ilist_node *ins);
	static ilist_node *erase(ilist_node *pos);

	static void splice(ilist_node *pos,ilist_node &other_header);
	static void splice(ilist_node *pos,ilist_node *i);
	static void splice(ilist_node *pos,ilist_node *first,ilist_node *last);

	size_type size(void) const;
	bool empty(void) const {return !header.linked();}

	void swap(base_intrusive_list &other) {header.swap(other.header);}

	static ilist_node *next(const ilist_node *node) {return node->next;}
	static ilist_node *prev(const ilist_node *node) {return node->prev;}

	class list_header : public base_intrusive_list_node
	{
	public:
		list_header(void) : base_intrusive_list_node() {}
		~list_header() {}
	};
	mutable list_header header;

private:
	base_intrusive_list(base_intrusive_list &);
	void operator=(base_intrusive_list &);
};

//	base_intrusive_list

inline void base_intrusive_list::clear(void)
{
	for (ilist_node *list = header.next;list != &header;list = erase(list))
		;
}

inline base_intrusive_list_node *
	base_intrusive_list::insert(ilist_node *pos,ilist_node *ins)
{
	assert(!ins->linked());
	ins->link_next(*pos);
	return ins;
}
inline base_intrusive_list_node *
	base_intrusive_list::insert_after(ilist_node *pos,ilist_node *ins)
{
	assert(!ins->linked());
	pos->link_next(*ins);
	return ins;
}

inline base_intrusive_list_node *
	base_intrusive_list::erase(ilist_node *pos)
{
	ilist_node *ret = pos->next;
	pos->unlink();
	return ret;
}

inline void
	base_intrusive_list::splice(ilist_node *pos,ilist_node &other_header)
{
	ilist_node *next = other_header.next;
	ilist_node *prev = other_header.prev;

	prev->next = pos;
	next->prev = pos->prev;

	pos->prev->next = other_header.next;
	pos->prev = other_header.prev;

	other_header.next = other_header.prev = &other_header;
}
inline void base_intrusive_list::splice(ilist_node *pos,ilist_node *i)
{
	assert(pos != i);
	i->prev->next = i->next;
	i->next->prev = i->prev;
	i->prev = pos->prev;
	i->next = pos;
	pos->prev->next = i;
	pos->prev = i;
}
inline void base_intrusive_list::splice(ilist_node *pos,
										ilist_node *first,ilist_node *last)
{
	assert(first != last);
	ilist_node *pos_prev = pos->prev;

	pos->prev->next = first;
	pos->prev = last->prev;

	last->prev->next = pos;
	last->prev = first->prev;

	first->prev->next = last;
	first->prev = pos_prev;
}
inline base_intrusive_list::size_type base_intrusive_list::size(void) const
{
	size_type count = 0;
	for (const ilist_node *ln = header.next;ln != &header;ln = ln->next)
		count++;
	return count;
}

//	N^oXgReiNX̃^O̐U蕪
template<int TagNumber>
class base_intrusive_list_ : public base_intrusive_list
{
protected:
	typedef base_intrusive_list base_class;
	typedef intrusive_list_node_<TagNumber> ilist_node;
	typedef base_class::size_type size_type;

	static ilist_node *insert(ilist_node *pos,ilist_node *ins)
		{return static_cast<ilist_node *>(base_class::insert(pos,ins));}
	static ilist_node *insert_after(ilist_node *pos,ilist_node *ins)
		{return static_cast<ilist_node *>(base_class::insert_after(pos,ins));}
	static ilist_node *erase(ilist_node *pos)
		{return static_cast<ilist_node *>(base_class::erase(pos));}

	static void splice(ilist_node *pos,ilist_node &other_header)
		{base_class::splice(pos,other_header);}
	static void splice(ilist_node *pos,ilist_node *i)
		{base_class::splice(pos,i);}
	static void splice(ilist_node *pos,ilist_node *first,ilist_node *last)
		{base_class::splice(pos,first,last);}

	void swap(base_intrusive_list_ &other) {base_class::swap(other);}

	static ilist_node *next(const ilist_node *node)
		{return static_cast<ilist_node *>(base_class::next(node));}
	static ilist_node *prev(const ilist_node *node)
		{return static_cast<ilist_node *>(base_class::prev(node));}
};

/*===========================================================================*/

//!	}[W
template <class IntrusiveListT,class BinaryPredicate>
void intrusive_list_merge(IntrusiveListT &list,IntrusiveListT &other,BinaryPredicate less);
//!	}[W\[g
template <int sort_stack_size,class IntrusiveListT,class BinaryPredicate>
void intrusive_list_sort(IntrusiveListT &list,BinaryPredicate less);


/*===========================================================================*/

//!	N^oXgReiNXev[g
/*!
	@sa intrusive_list.hpp
*/
template<class DerivedNode,int TagNumber = 0>
class intrusive_list : private base_intrusive_list_<TagNumber>
{
	typedef base_intrusive_list_<TagNumber> base_class;
	typedef base_class::ilist_node ilist_node;
	typedef base_class::size_type size_type;
	typedef DerivedNode			node_type;
	typedef DerivedNode *		pointer;
	typedef const DerivedNode *	const_pointer;
	typedef DerivedNode &		reference;
	typedef const DerivedNode &	const_reference;

//	Ce[^p|V[
	struct normal_step
	{
		template<class T> static T *inc(T *node) {return next(node);}
		template<class T> static T *dec(T *node) {return prev(node);}
	};
//	tCe[^p|V[
	struct reverse_step
	{
		template<class T> static T *inc(T *node) {return prev(node);}
		template<class T> static T *dec(T *node) {return next(node);}
	};
//	node|C^쌠^
	friend struct normal_step;
	friend struct reverse_step;

//	Ce[^̎
	template<class StepPolicy>
	class base_const_iterator
	{
	public:
		typedef std::bidirectional_iterator_tag iterator_category;
		typedef ptrdiff_t difference_type;
		typedef ptrdiff_t distance_type;

	protected: friend class intrusive_list<node_type,TagNumber>;
		base_const_iterator(pointer p) : node(p) {}
	public:
		base_const_iterator(void) : node(0) {}
		template<class S>
		base_const_iterator(base_const_iterator<S> &src) : node(src.get()) {}

		reference operator*(void) const {return *node;}
		pointer operator->(void) const {return node;}

		base_const_iterator operator++(void) {increment();return *this;}
		base_const_iterator operator++(int) {base_const_iterator r = *this;increment();return r;}
		base_const_iterator operator--(void) {decrement();return *this;}
		base_const_iterator operator--(int) {base_const_iterator ret = *this;decrement();return ret;}

		template<class S>
		bool operator==(const base_const_iterator<S> &rhs) const {return node == rhs.get();}
		template<class S>
		bool operator!=(const base_const_iterator<S> &rhs) const {return node != rhs.get();}

		pointer get(void) const {return node;}

	protected:
		void increment(void) {node = StepPolicy().inc(node);}
		void decrement(void) {node = StepPolicy().dec(node);}
		pointer node;
	};

	template<class StepPolicy>
	class base_iterator : public base_const_iterator<StepPolicy>
	{
	private: friend class intrusive_list<node_type,TagNumber>;
		base_iterator(pointer p) : base_const_iterator<StepPolicy>(p) {}
	public:
		base_iterator(void) {}
		template<class S>
		base_iterator(base_iterator<S> &src) : base_const_iterator(src) {}

		base_iterator operator++(void) {this->increment();return *this;}
		base_iterator operator++(int) {base_iterator r = *this;this->increment();return r;}
		base_iterator operator--(void) {this->decrement();return *this;}
		base_iterator operator--(int) {base_iterator ret = *this;this->decrement();return ret;}
	};
//	֗֐
	static pointer next(const ilist_node *node) {return static_cast<pointer>(base_class::next(node));}
	static pointer prev(const ilist_node *node) {return static_cast<pointer>(base_class::prev(node));}
	static pointer cast(ilist_node *node) {return static_cast<pointer>(node);}
	static pointer next(const_pointer node) {return static_cast<pointer>(base_class::next(node));}
	static pointer prev(const_pointer node) {return static_cast<pointer>(base_class::prev(node));}

	ilist_node &header(void) const {return static_cast<ilist_node &>(static_cast<base_intrusive_list_node &>(base_class::header));}

public:
//!	Ce[^ (bidirectional_iterator)
	typedef base_iterator<normal_step> iterator;
//!	RXgCe[^ (bidirectional_iterator)
	typedef base_const_iterator<normal_step> const_iterator;
//!	o[XCe[^
	typedef base_iterator<reverse_step> reverse_iterator;
//!	RXgo[XCe[^
	typedef base_const_iterator<reverse_step> const_reverse_iterator;

//!	ftHgRXgN^
/*!	ȊOɃRXgN^͖ */
	intrusive_list(void) : base_intrusive_list_<TagNumber>() {}
//!	fXgN^
/*!	clear()Ă */
	~intrusive_list() {clear();}

//!	@name Svfr
//@{
//!	Svfr
/*!	̃Xg̑SvfXgrB */
	void clear(void) {base_class::clear();}
//@}

//!	@name vf
//@{
//!	vf
/*!	XgǂĐ܂B */
	size_type size(void) const {return base_class::size();}
//!	Xg󂩂ǂ
/*!	size()葬 size() == 0 */
	bool empty(void) const {return base_class::empty();}
//@}

//!	@name [̗vfQ
//@{
//!	擪vfQ
/*! @pre empty() == false */
	reference front(void) {return *next(&header());}
//!	擪vfRXgQ
/*! @pre empty() == false */
	reference front(void) const {return *next(&header());}

//!	vfQ
/*! @pre empty() == false */
	reference back(void) {return *prev(&header());}
//!	vfRXgQ
/*! @pre empty() == false */
	reference back(void) const {return *prev(&header());}
//@}

//!	@name X^bN
//@{
//!	擪ւpush
/*!
	Xg̐擪ins}B
	@pre assert(ins.linked() == false)
*/
	void push_front(reference ins) {base_class::insert_after(&header(),&ins);}
//!	ւpush
/*!
	Xg̖ins}B
	@pre assert(ins.linked() == false)
*/
	void push_back(reference ins) {base_class::insert(&header(),&ins);}

//!	擪vfpop
/*!
	擪vfrB
	@pre empty() == false
*/
	void pop_front(void) {base_class::erase(next(&header()));}
//!	vfpop
/*!
	vfrB
	@pre empty() == false
*/
	void pop_back(void) {base_class::erase(prev(&header()));}
//@}

//!	@name Ce[^
//@{
//!	擪Ce[^
	iterator begin(void) {return next(&header());}
//!	RXg擪Ce[^
	const_iterator begin(void) const {return next(&header());}
//!	I[Ce[^
	iterator end(void) {return cast(&header());}
//!	RXgI[Ce[^
	const_iterator end(void) const {return cast(&header());}
//!	t擪Ce[^
	reverse_iterator rbegin(void) {return prev(&header());}
//!	RXgt擪Ce[^
	const_reverse_iterator rbegin(void) const {return prev(&header());}
//!	tI[Ce[^
	reverse_iterator rend(void) {return cast(&header());}
//!	RXgtI[Ce[^
	const_reverse_iterator rend(void) const {return cast(&header());}
//@}


//	}ArAqւ
//	ʒuwCe[^ɂˑȂAςȊ邪Sstatic
//	悭ȂǃCe[^QƂŎ󂯂ȂƁufatal error C1001vN邱Ƃ
//	ǂɂĂVC6낤ǁB

//!	@name }
//@{
//!	vf̑}
/*!
	pos̈ʒuins}B
	@return }vfwCe[^
	@pre assert(ins.linked() == false)
*/
	iterator insert(iterator pos,reference ins)
		{return cast(base_class::insert(pos.get(),&ins));}
//!	vf̑}
/*!
	pos̎̈ʒuins}B
	@return }vfwCe[^
	@pre assert(ins.linked() == false)
*/
	iterator insert_after(iterator pos,reference ins)
		{return cast(base_class::insert_after(pos.get(),&ins));}
//@}

//!	@name r
//@{
//!	vf̔r
/*!
	pos̗vfXgrB
	@return 폜vf̗̎vfwCe[^
	@post pos̗vfւ̎QƂ͗LB
*/
	iterator erase(iterator pos)
		{return cast(base_class::erase(pos.get()));}
//!	vf̔r
/*!
	pos̗̎vfXgrB
	@return 폜vf̗̎vfwCe[^
*/
	iterator erase_after(iterator pos)
		{return cast(base_class::erase(next(pos.get())));}
//@}

//!	@name vf̌qւ
//@{
//!	vf̌qւ
/*!
	l̑Svfpos̈ʒuɌqւBl͋ɂȂB
*/
	void splice(iterator pos,intrusive_list &l)
		{base_class::splice(pos.get(),l.header());}
//!	vf̌qւ
/*!
	i̗vfpos̈ʒuɌqւB
	@pre assert(pos != i)
*/
	void splice(iterator pos,intrusive_list &,iterator i)
		{splice(pos,i);}
//!	vf̌qւ
/*!
	[first-last)͈̔͂ɂvfpos̈ʒuɌqւB
	@pre assert(first != last)
	@pre first-lastԂposĂ͂ȂȂB
*/
	void splice(iterator pos,intrusive_list &,iterator first,iterator last)
		{splice(pos,first,last);}
//@}

//!	@name vf̌qւ
//@{
//!	vf̌qւ
/*!
	i̗vfpos̈ʒuɌqւB
	@pre assert(pos != i)
	݊p̂Ȃ
*/
	static void splice(iterator pos,iterator i)
		{base_class::splice(pos.get(),i.get());}
//!	vf̌qւ
/*!
	[first-last)͈̔͂ɂvfpos̈ʒuɌqւB
	@pre assert(first != last)
	@pre first-lastԂposĂ͂ȂȂB
	݊p̂Ȃ
*/
	static void splice(iterator pos,iterator first,iterator last)
		{base_class::splice(pos.get(),first.get(),last.get());}


//!	@name ASY
//@{
//!	XgԂ̗vf̑S
/*!	lƗvfSČ */
	void swap(intrusive_list &l) {base_class::swap(l);}

//!	}[W
/*!
	otheȓSvfBother͋ɂȂB\n
	gAotherlessŃ\[gĂlessŃ\[gŊi[B\n
	łȂΊi[鏇͕sB
	@param other }[WċɂȂ郊Xg
	@param less vfrq֐IuWFNg
*/
	template <class BinaryPredicate>
	void merge(intrusive_list &other,BinaryPredicate less)
		{intrusive_list_merge(*this,other,less);}

//!	}[W\[g
/*!
	vflessŔrʂɂĕёւB
	@pre assert(size() <= (2^16 * 2))\n
		ۂɂsize()ĂԂ킯ł͂ȂA
		EɒB_assert(false)ƂȂB
	@param less vfrq֐IuWFNg
*/
	template <class BinaryPredicate>
	void sort(BinaryPredicate less)
		{intrusive_list_sort<16>(*this,less);}

//	ꂾ̂߂#include <functional>Ȃ̂
	struct less
	{bool operator()(const_reference lhs,const_reference rhs) const {return lhs < rhs;}};

//	AȂ񂩂Predicate𒼐ڎw肷xBǂɂĂVC6i

//!	}[W
/*!
	otheȓSvfBother͋ɂȂB\n
	gAotherɃ\[gĂ΃\[gŊi[B\n
	łȂΊi[鏇͕sB
	@param other }[WċɂȂ郊Xg
*/
	void merge(intrusive_list &other) {merge(other,less());}
//!	}[W\[g
/*!
	vf<ZqŔrʂɂĕёւB
	@pre assert(size() <= (2^16 * 2))\n
		ۂɂsize()ĂԂ킯ł͂ȂA
		EɒB_assert(false)ƂȂB
*/
	void sort(void) {sort(less());}


//!	vftɕבւ
	void reverse(void)
	{
		for (iterator i = begin();i != --end();splice(i,--end()))
			;
	}

//!	vvfr
/*!	x == val trueƂȂvfxerase()B */
	void remove(const_reference val)
	{
		for (iterator it = begin();it != end();)
			if (*it == val)
				it = erase(it);
			else
				++it;
	}
//!	Ɉvvfr
/*!	test(x) trueƂȂvfxerase()B */
	template <class UnaryPredicate>
	void remove_if(UnaryPredicate test)
	{
		for (iterator it = begin();it != end();)
			if (test(*it))
				it = erase(it);
			else
				++it;
	}
//@}

//	void unique(void);
//	template <class BinaryPredicate>
//	void unique(BinaryPredicate equal);


//operator==()ƂgH


//! @name \[gςݑ
//@{
//!	\[gςݑ}
/*!
	lessŃ\[gĂ΁Ains\[gꂽʒuɑ}B\n
	łȂΑ}ʒu͕sB
	@return }vfwCe[^
	@pre assert(ins.linked() == false)
*/
	template <class BinaryPredicate>
	iterator insert(reference ins,BinaryPredicate less)
	{
		for (iterator i = begin();i != end();++i)
			if (less(ins,*i))
				return insert(i,ins);
		return insert(end(),ins);
	}
//!	\[gς݌qւ
/*!
	lessŃ\[gĂ΁Ai\[gꂽʒuɌqւB\n
	łȂΌqւʒu͕sB
	@pre assert(ins.linked() == false)
	@post i͌qւꂽ̗vfwĂB
*/
	template <class BinaryPredicate>
	void splice(iterator i,BinaryPredicate less)
	{
		for (iterator it = begin();it != end();++it)
			if (less(*i,*it))
				{splice(it,i);return;}
		splice(end(),i);
	}
//!	\[gςݑ}
/*!
	\[gĂ΁Ains\[gꂽʒuɑ}B\n
	łȂΑ}ʒu͕sB
	@return }vfwCe[^
	@pre assert(ins.linked() == false)
*/
	iterator insert(reference ins) {return insert(ins,less());}
//!	\[gς݌qւ
/*!
	\[gĂ΁Ai\[gꂽʒuɌqւB\n
	łȂΌqւʒu͕sB
	@pre assert(ins.linked() == false)
	@post i͌qւꂽ̗vfwĂB
*/
	void splice(iterator i) {return splice(i,less());}
//@}


//!	R[h
/*!	vf̌^ςQƂ𓾂 */
	template<typename U,int TagNumber>
	intrusive_list<U,TagNumber> &static_cast_element_list(void)
	{
		return static_cast<intrusive_list<node_type,TagNumber> &>(static_cast<base_intrusive_list_<TagNumber> &>(*this));
		static_cast<U *>(static_cast<node_type *>(0));
	}
	template<typename U,int TagNumber>
	intrusive_list<U,TagNumber> &static_cast_element_list(void) const
	{
		return static_cast<const intrusive_list<U,TagNumber> &>(static_cast<const base_intrusive_list_<TagNumber> &>(*this));
		static_cast<U *>(static_cast<node_type *>(0));
	}
	intrusive_list<const node_type,TagNumber> &const_element_list(void)
	{
		return static_cast<intrusive_list<const node_type,TagNumber> &>(static_cast<base_intrusive_list_<TagNumber> &>(*this));
	}
	const intrusive_list<const node_type,TagNumber> &const_element_list(void) const
	{
		return static_cast<const intrusive_list<const node_type,TagNumber> &>(static_cast<const base_intrusive_list_<TagNumber> &>(*this));
	}
};
//template<class DerivedNode,int TagNumber> class intrusive_list



//!	XgԂ̗vfS
/*!	l1l2̗vfSČ */
template<class T,int N>
void swap(intrusive_list<T,N> &l1,intrusive_list<T,N> &l2) {l1.swap(l2);}

/*!
	otheȓSvflistɎBother͋ɂȂB\n
	list,otherlessŃ\[gĂlessŃ\[gŊi[B\n
	łȂΊi[鏇͕sB
	@param list }[WČʂi[郊Xg
	@param other }[WċɂȂ郊Xg
	@param less vfrq֐IuWFNg
*/
template <class IntrusiveListT,class BinaryPredicate>
void intrusive_list_merge(IntrusiveListT &list,IntrusiveListT &other,BinaryPredicate less)
{
	assert(&list != &other);
	if (list.empty() || other.empty())
	{
		list.splice(list.end(),other);
		return;
	}
	for (IntrusiveListT::iterator pos = list.begin();;)
	{
		if (less(other.front(),*pos))
		{
			list.splice(pos,other.begin());
			if (other.empty())
				break;
		}
		else
		{
			if (++pos == list.end())
			{
				list.splice(list.end(),other);
				break;
			}
		}
	}
}

/*!
	vflessŔrʂɂĕёւB\n
	ev[gŃ\[gpX^bNTCYwł
	@pre assert(size() <= (2^sort_stack_size * 2))\n
		ۂɂsize()ĂԂ킯ł͂ȂA
		EɒB_assert(false)ƂȂB

	@param sort_stack_size X^bNTCY

	@param list \[g郊Xg
	@param less vfrq֐IuWFNg
*/
template <int sort_stack_size,class IntrusiveListT,class BinaryPredicate>
void intrusive_list_sort(IntrusiveListT &list,BinaryPredicate less)
{
	IntrusiveListT stack[sort_stack_size];	//Ɨ̈
	int m_count[sort_stack_size] = {0};		//}[W

	int n = 0;
	while (!list.empty())
	{
		list.splice(stack[n].end(),list.begin());
		if (!list.empty())
		{
			if (less(list.front(),stack[n].front()))
				list.splice(stack[n].begin(),list.begin());
			else
				list.splice(stack[n].end(),list.begin());
		}
		m_count[n] = 1;

		int i;
		for (i = n;i > 0;i--)
		{
			if (m_count[i] != m_count[i-1])
				break;
			stack[i-1].merge(stack[i],less);
			m_count[i-1] += m_count[i];
		}
		n = i+1;
//	X^bNI[o[t[Ǝ
		assert(n < sort_stack_size);
	}
//	for (int i = 0;i < n;i++)
//		merge(stack[i],less);
	for (int i = n-1;i > 0;i--)
		stack[i-1].merge(stack[i],less);
	list.splice(list.end(),stack[0]);
}


}//namespace Juna


#endif
