
#include "NWayShooter.h"


void OddWayShooter::Shoot(
	Generator &generator,const Point &pos,RadianAngle dir,
	I_Shooter &shooter,unsigned halfWay,RadianAngle spaceAngle)
{
	RadianAngle addAngle = spaceAngle;
	shooter.Shoot(generator,pos,dir);
	for (unsigned i = 0;i < halfWay;i++)
	{
		shooter.Shoot(generator,pos,dir + addAngle);
		shooter.Shoot(generator,pos,dir - addAngle);
		addAngle += spaceAngle;
	}
}


void EvenWayShooter::Shoot(
	Generator &generator,const Point &pos,RadianAngle dir,
	I_Shooter &shooter,unsigned halfWay,RadianAngle spaceAngle)
{
	RadianAngle addAngle = spaceAngle/2;
	for (unsigned i = 0;i < halfWay;i++)
	{
		shooter.Shoot(generator,pos,dir + addAngle);
		shooter.Shoot(generator,pos,dir - addAngle);
		addAngle += spaceAngle;
	}
}


void OddParallelShooter::Shoot(
	Generator &generator,const Point &pos,RadianAngle dir,
	I_Shooter &shooter,unsigned halfWay,float space)
{
	shooter.Shoot(generator,pos,dir);
	Vector spacev(-dir.sin() * space,dir.cos() * space);
	Vector r(0,0);
	for (unsigned i = 0;i < halfWay;i++)
	{
		r += spacev;
		shooter.Shoot(generator,pos + r,dir);
		shooter.Shoot(generator,pos - r,dir);
	}

}

void EvenParallelShooter::Shoot(
	Generator &generator,const Point &pos,RadianAngle dir,
	I_Shooter &shooter,unsigned halfWay,float space)
{
	Vector spacev(-dir.sin() * space,dir.cos() * space);
	Vector r(0,0);
	for (unsigned i = 0;i < halfWay;i++)
	{
		r += spacev;
		shooter.Shoot(generator,pos + r,dir);
		shooter.Shoot(generator,pos - r,dir);
	}

}
