
#ifndef Game_N_Way_Shooter_H
#define Game_N_Way_Shooter_H

#include "Weapon.h"


//ei2*halfWay+1j
class OddWayShooter : public I_Shooter
{
public:
	OddWayShooter(I_Shooter &shooter,int halfWay,RadianAngle spaceAngle)
		: Shooter(shooter),HalfWay(halfWay),SpaceAngle(spaceAngle)
	{}

	virtual void Shoot(Generator &generator,const Point &pos,RadianAngle dir)
	{
		Shoot(generator,pos,dir,Shooter,HalfWay,SpaceAngle);
	}
	virtual float SetSpeed(float speed) {return Shooter.SetSpeed(speed);}

	static void Shoot(Generator &generator,const Point &pos,RadianAngle dir,
					  I_Shooter &shooter,
					  unsigned halfWay,RadianAngle spaceAngle);
private:
	I_Shooter &Shooter;
	unsigned HalfWay;
	RadianAngle SpaceAngle;
};

//ei2*halfWayj
class EvenWayShooter : public I_Shooter
{
public:
	EvenWayShooter(I_Shooter &shooter,int halfWay,RadianAngle spaceAngle)
		: Shooter(shooter),HalfWay(halfWay),SpaceAngle(spaceAngle)
	{}

	virtual void Shoot(Generator &generator,const Point &pos,RadianAngle dir)
	{
		Shoot(generator,pos,dir,Shooter,HalfWay,SpaceAngle);
	}
	virtual float SetSpeed(float speed) {return Shooter.SetSpeed(speed);}

	static void Shoot(Generator &generator,const Point &pos,RadianAngle dir,
					  I_Shooter &shooter,
					  unsigned halfWay,RadianAngle spaceAngle);
private:
	I_Shooter &Shooter;
	unsigned HalfWay;
	RadianAngle SpaceAngle;
};

//nWaye
class NWayShooter : public I_Shooter
{
public:
	NWayShooter(I_Shooter &shooter,int halfWay,RadianAngle spaceAngle,float speed)
		: Shooter(shooter),HalfWay(halfWay),SpaceAngle(spaceAngle)
	{}

	virtual void Shoot(Generator &generator,const Point &pos,RadianAngle dir)
	{
		Shoot(generator,pos,dir,Shooter,HalfWay,SpaceAngle);
	}
	virtual float SetSpeed(float speed) {return Shooter.SetSpeed(speed);}

	static void Shoot(Generator &generator,const Point &pos,RadianAngle dir,
					  I_Shooter &shooter,
					  unsigned way,RadianAngle spaceAngle)
	{
		typedef void (*typeNWayFunc)(Generator &,const Point &,RadianAngle,
									 I_Shooter &,unsigned,RadianAngle);
		const typeNWayFunc NWayFunc[2] = {EvenWayShooter::Shoot,OddWayShooter::Shoot};
		NWayFunc[way & 1](generator,pos,dir,shooter,way/2,spaceAngle);
	}

private:
	I_Shooter &Shooter;
	unsigned HalfWay;
	RadianAngle SpaceAngle;
};


//sei2*halfWay+1j
class OddParallelShooter : public I_Shooter
{
public:
	OddParallelShooter(I_Shooter &shooter,int halfWay,float space)
		: Shooter(shooter),HalfWay(halfWay),Space(space)
	{}

	virtual void Shoot(Generator &generator,const Point &pos,RadianAngle dir)
	{
		Shoot(generator,pos,dir,Shooter,HalfWay,Space);
	}
	virtual float SetSpeed(float speed) {return Shooter.SetSpeed(speed);}

	static void Shoot(Generator &generator,const Point &pos,RadianAngle dir,
					  I_Shooter &shooter,unsigned halfWay,float space);
private:
	I_Shooter &Shooter;
	int HalfWay;
	float Space;
};

//sei2*halfWayj
class EvenParallelShooter : public I_Shooter
{
public:
	EvenParallelShooter(I_Shooter &shooter,int halfWay,float space)
		: Shooter(shooter),HalfWay(halfWay),Space(space)
	{}

	virtual void Shoot(Generator &generator,const Point &pos,RadianAngle dir)
	{
		Shoot(generator,pos,dir,Shooter,HalfWay,Space);
	}
	virtual float SetSpeed(float speed) {return Shooter.SetSpeed(speed);}

	static void Shoot(Generator &generator,const Point &pos,RadianAngle dir,
					  I_Shooter &shooter,unsigned halfWay,float space);
private:
	I_Shooter &Shooter;
	int HalfWay;
	float Space;
};

#endif
