
#include "PNG_File.h"
//#include "Juna/Picture/Image.h"
//#include "Juna/Picture/Blit.h"

#include "PNG_DLL.h"

#pragma comment (lib,"PNG.lib")

namespace {
struct ReaderCloser
{
	ReaderCloser(PNG_Reader *reader) : reader(reader) {}
	~ReaderCloser() {PNG_CloseReader(reader);}
	PNG_Reader *reader;
};
}//	anonymous namespace

bool LoadPNGFile(Juna::Picture::I_Image &dest,const char *filename)
{
	PNG_Reader *reader = PNG_OpenReadFile(filename);
	if (!reader)
		return false;
	ReaderCloser closer(reader);

	int h = PNG_GetReaderHeight(reader);
	if (dest.height() < h)
		h = dest.height();
	for (int i = 0;i < h;i++)
	{
		if (!PNG_ReadLineBGRA(reader,dest[i],dest.width()))
			return false;
	}
	return true;
}
bool InitLoadPNGFile(Juna::Picture::Image &dest,const char *filename)
{
	PNG_Reader *reader = PNG_OpenReadFile(filename);
	if (!reader)
		return false;
	ReaderCloser closer(reader);

	long w = PNG_GetReaderWidth(reader),h = PNG_GetReaderHeight(reader);
	dest.Initialize(w,h);
	for (long i = 0;i < h;i++)
	{
		if (!PNG_ReadLineBGRA(reader,dest[i],w))
			return false;
	}
	return true;
}
