
#ifndef GAME_Shooting_H
#define GAME_Shooting_H

#include "Scene.h"
#include "Juna/D2D/Direct2D.h"
#include "Input.h"


#include "Entity.h"
#include "Visual.h"
#include "Attack.h"
#include "Observe.h"
#include "Obstruct.h"

#include "Allocator.h"
#include "Generator.h"

#include "Player.h"

class Force
{
public:
	AttackManager Attack;
	ObserveManager Observe;
	ObstructManager Obstruct;
	Generator Generator;
	Allocator Allocator;

	Force(I_EntityCreator &entity_creator,I_VisualCreator &visual_creator)
		: Generator(entity_creator,visual_creator,
					Attack.dCreator,Attack.rCreator,
					Observe.dCreator,Observe.rCreator,
					Obstruct.dCreator,Obstruct.rCreator,
					Allocator)
	{}
};


class ShootingScene : public I_Scene
{
public:
	ShootingScene(void)
	  : ForceA(Entities.Creator,Visuals),
		ForceB(Entities.Creator,Visuals)
	{
		ForceA.Allocator.Initialize(256,256);
		ForceB.Allocator.Initialize(256,1024);
	}

	bool Initialize(Juna::D2D::I_ScreenSurface &screen,
					Juna::D2D::I_SpriteSurface &sprite,
					Juna::D2D::I_SpriteSurface &ascii,
					Juna::D2D::I_ScreenSurface &bg,
					const Juna::Input::I_GameController &input);
	void Terminalize(void);


	void ClearEntities(void) {Entities.Clear();}

	virtual I_Scene *Action(void);

private:
	void RealizeCreature(void)
	{
		Entities.RealizeCreature();
		ForceA.Attack.RealizeCreature();
		ForceB.Attack.RealizeCreature();
		ForceA.Observe.RealizeCreature();
		ForceB.Observe.RealizeCreature();
		ForceA.Obstruct.RealizeCreature();
		ForceB.Obstruct.RealizeCreature();
	}

private:
	Juna::D2D::I_ScreenSurface *Screen;
	Juna::D2D::I_SpriteSurface *Sprite;
	Juna::D2D::I_SpriteSurface *Ascii;
	Juna::D2D::I_ScreenSurface *BG;

	const Juna::Input::I_GameController *Input;

	EntityManager Entities;
	VisualManager Visuals;

	Force ForceA;
	Force ForceB;

	PlayerController PCInput;

};

#endif
