
#ifndef Game_Shot_H
#define Game_Shot_H

#include "TypeDef.h"

#include "Entity.h"
#include "Visual.h"
#include "Attack.h"
//#include "Observe.h"

#include "Generator.h"


class Shot : public I_Entity, public I_Visual, public I_Attacker
{
private:
	Shot(Generator &generator,
		 const Point &position,float angle,const Vector & velocity);
	~Shot() {}
public:
	static Shot *Create(Generator &generator,const Point &position,float angle,const Vector & velocity);

	virtual bool Update(void);
	virtual void Break(void);
	virtual void Attack(const AttackParam &param);
	virtual void Visualize(const VisualizeParam &param) const;

	const Point &position(void) const {return Position;}
	float range(void) const {return Range;}

private:
	Point Position;
	float Angle;
	Vector Velocity;
	float Range;

	uint32 Power;
	int32 LifeCounter;
};


//ђʒe
class PiercingShot : public I_Entity, public I_Visual, public I_Attacker
{
private:
	PiercingShot(Generator &generator,
		 const Point &position,float angle,const Vector & velocity);
	~PiercingShot() {}
public:
	static PiercingShot *Create(Generator &generator,const Point &position,float angle,const Vector & velocity);

	virtual bool Update(void);
	virtual void Break(void);
	virtual void Attack(const AttackParam &param);
	virtual void Visualize(const VisualizeParam &param) const;

	const Point &position(void) const {return Position;}
	float range(void) const {return Range;}

private:
	Point Position;
	float Angle;
	Vector Velocity;
	float Range;

	uint32 Power;
	int32 LifeCounter;
};


//ђʂȂ[U[
class LaserShot : public I_Entity, public I_Visual, public I_Attacker
{
private:
	LaserShot(::Generator &generator,
		 const Point &position,float angle);
	~LaserShot() {}
public:
	static LaserShot *Create(::Generator &generator,const Point &position,float angle);

	virtual bool Update(void);
	virtual void Break(void);
	virtual void Attack(const AttackParam &param);
	virtual void Visualize(const VisualizeParam &param) const;

private:
	Point Position;
	RadianAngle Direction;
	float Length;
	float Width;

	uint32 Power;
	int32 LifeCounter;
	Generator &Generator;
};

#endif
