
#include "SoundManager.h"
#include "Sounder.h"

#include "ACM_Reader.h"

using namespace Juna::Sound;

SoundManager::SoundManager(void)
 :	Driver(0), BGMPlayer(0), SE1_Index(0), SE2(0)
{
	SE1[0] = SE1[1] = 0; 
}

SoundManager::~SoundManager()
{
	Terminalize();
}


class AutoReleaser
{
	I_InputStream *Ptr;
public:
	AutoReleaser(I_InputStream *ptr) : Ptr(ptr) {}
	~AutoReleaser() {if (Ptr) Ptr->Release();}
private:
	AutoReleaser(const AutoReleaser &);
	AutoReleaser &operator=(const AutoReleaser &);

};

bool SoundManager::Initialize(void)
{
	Driver = GetPlayDriverInterface(0);	//DirectSound Driver
	if (!Driver)
		return false;

	Format format(44100,16,1);
	BGMPlayer = Driver->CreateStreamPlayer(0,format);
	if (!BGMPlayer)
		goto ERR;
	{
		ACM_FileReader *reader = ACM_FileReader::Create();
		AutoReleaser releaser(reader);
		if (!reader)
			goto ERR;
		if (!reader->OpenWaveFile("wav/burst0.wav"))
			goto ERR;
		SE1[0] = Driver->CreatePoolPlayer(0,*reader);
		if (!SE1[0])
			goto ERR;
		SE1[1] = Driver->CreatePoolPlayer(*SE1[0]);
		if (!SE1[1])
			goto ERR;
		if (!reader->OpenWaveFile("wav/b_hit.wav"))
			goto ERR;
		SE2 = Driver->CreatePoolPlayer(0,*reader);
		if (!SE2)
			goto ERR;
	}

	Sounder::instance.Manager = this;

	return true;
ERR:;
	Terminalize();
	return false;
}
void SoundManager::Terminalize(void)
{
	Sounder::instance.Manager = 0;

	if (Driver)
	{
		if (SE2)
			Driver->DestroyPlayer(SE2);
		SE2 = 0;
		for (int i = 0;i < 2;i++)
		{
			if (SE1[i])
				Driver->DestroyPlayer(SE1[i]);
			SE1[i] = 0;
		}

		if (BGMPlayer)
			Driver->DestroyPlayer(BGMPlayer);
		BGMPlayer = 0;
	}
	Driver = 0;
}


void SoundManager::PlaySE1(void)
{
	I_Player &se1 = *SE1[SE1_Index];
	SE1_Index = SE1_Index + 1 & 1;
	se1.Stop();
	se1.Start();
}

void SoundManager::PlaySE2(void)
{
	SE2->Stop();
	SE2->Start();
}
