
#include "TitleScene.h"
#include "ShootingScene.h"

void DrawASCIIString(Juna::D2D::I_ScreenSurface &screen,Juna::D2D::I_SpriteSurface &sprite,
					 int x,int y,const char *string);
void DrawNumber(Juna::D2D::I_ScreenSurface &screen,Juna::D2D::I_SpriteSurface &sprite,
				int x,int y,unsigned num,unsigned figure = 4,bool fillzero = false);


bool TitleScene::Initialize(
	Juna::D2D::I_ScreenSurface &screen,
	Juna::D2D::I_SpriteSurface &sprite,
	Juna::D2D::I_SpriteSurface &ascii,
	const Juna::Input::I_GameController &input,
	ShootingScene &shooting)
{
	if (!screen.isValid() || !sprite.isValid() || !ascii.isValid())
		return false;

	Screen = &screen;
	Sprite = &sprite;
	Ascii = &ascii;
	Input = &input;
	Shooting = &shooting;
	return true;
}



I_Scene *TitleScene::Action(void)
{
	using namespace Juna;
	using namespace D2D;

	float x,y;
	bool ok;
	bool cancel;
	x = Input->x_axis();
	y = Input->y_axis();
	ok = Input->buttonState(0);
	cancel = Input->buttonState(1);

	if (ok)
	{
//		Shooting->Initialize();
		return Shooting;
	}
	if (cancel)
	{
		return 0;
	}

	{	//`
/*
		{
			FRect frc(0,0,800,600);
			static int scroll;
			Rect rc(0,scroll,256 * 6 ,256 * 6 + scroll);
//*
			D2D::I_ScreenSurface::FreeBlitPoint fbp[4];
			fbp[0].Set(frc.left + 192,frc.top,0,0,0,0);
			fbp[1].Set(frc.right - 192,frc.top,0,0,0,0);
			fbp[2].Set(frc.right + 256,frc.bottom,255,255,255,255);
			fbp[3].Set(frc.left  - 256,frc.bottom,255,255,255,255);
			screen.FreeBlitPerspective(fbp,Draw.BG,rc);
//			screen.FreeFillPerspective(fbp);
//			screen.FreeBlit(fbp,Draw.BG,rc);
//			screen.FreeFill(fbp);
/*/
//			screen.Blit(frc,Draw.BG,rc);
//*/
//			scroll -= 4;
//		}

		DrawASCIIString(*Screen,*Ascii,128,128,"Untitled Shooting");
	}
	return this;
}

