
#ifndef Game_Unit_Control_H
#define Game_Unit_Control_H


#include "TypeDef.h"
#include "Observe.h"


class I_Unit
{
protected:
	~I_Unit() {}
public:
	virtual void Move(RadianAngle direction) = 0;
	virtual void Turn(RadianAngle direction) = 0;
	virtual void Act(unsigned int command) = 0;

	virtual const Point &position(void) const = 0;
	virtual RadianAngle direction(void) const = 0;
	virtual float damageRate(void) const {return 0;}
};

class I_UnitController
{
protected:
	~I_UnitController() {}
public:
	virtual void UnitControl(I_Unit &controlled,const ObserveParam &observed) = 0;
	virtual void UnitBreak(I_Unit &controlled) {}
};


#endif
