
#include "Wall.h"
#include "GameDefine.h"

Wall::Wall(::Generator &generator)
  : I_Entity(generator.Entity),
	I_Obstructor(generator.Obstructor),
	I_Attacker(generator.Attacker),
	Generator(generator)
{
}

Wall *Wall::Create(::Generator &generator)
{
	return new Wall(generator);
}

bool Wall::Update(void)
{
	return true;
}
void Wall::Break(void)
{
	delete this;
}

void Wall::Obstruct(const ObstructParam &param)
{
	typedef ObstructParam::list list;
	const list &enemy = param.Enemy;
	for (list::const_iterator it = enemy.begin();it != enemy.end();++it)
	{
		I_Obstructed::Data data = it->obstructedData();
		data.position += data.velocity;

		Vector pressure(0,0);
		if (data.position.x - data.radius < StgViewLeft)
			pressure.x = StgViewLeft - (data.position.x - data.radius);
		if (data.position.x + data.radius > StgViewRight)
			pressure.x = StgViewRight - (data.position.x + data.radius);
		if (data.position.y - data.radius < StgViewTop)
			pressure.y = StgViewTop - (data.position.y - data.radius);
		if (data.position.y + data.radius > StgViewBottom)
			pressure.y = StgViewBottom - (data.position.y + data.radius);

		Pressure(*it,pressure);
	}
}


void Wall::Attack(const AttackParam &param)
{
/*
	struct Area : public Juna::D2::Intersection::I_LineDividedArea
	{
		Area(void) {}
		virtual Data GetLineDividedAreaData(void) const
		{
			return Data(0,1,-480,false);
		}
	};
	Area a;

	typedef AttackParam::list list;
	const list &enemy = param.Enemy;
	for (list::const_iterator it = enemy.begin();it != enemy.end();++it)
	{
		if (it->shape().Test(a))
		{
			Damage(*it,0,Vector(0,-1));
		}
	}
*/
}
