
#ifndef Game_XLaser_H
#define Game_XLaser_H

#include "TypeDef.h"

#include "Entity.h"
#include "Visual.h"
#include "Observe.h"
#include "Attack.h"

#include "Generator.h"

#include "mutual_ptr.hpp"

class XLaser : public I_Entity, public I_Visual, public I_Observer, public I_Attacker,
			   public Juna::mutual_ptr_pointed
{
private: friend class XLaserGun;
	XLaser(Generator &generator,
		   const Point &pos,RadianAngle dir,float speed);
	~XLaser() {}
public:

	virtual bool Update(void);
	virtual void Break(void);
	virtual void Visualize(const VisualizeParam &param) const;
	virtual void Observe(const ObserveParam &param);
	virtual void Attack(const AttackParam &param);

	const Point &position(void) const {return Position;}
	RadianAngle direction(void) const {return Direction;}
	float range(void) const {return Range;}

private:
	Point Position;
	RadianAngle Direction;
	Vector Velocity;
	float Speed;
	float Range;

	uint32 Power;
	int32 LifeCounter;

	Juna::mutual_ptr<XLaser> prev;
};

class XLaserGun
{
public:
	XLaserGun(void) {}
	~XLaserGun() {}
	XLaser *Shoot(Generator &generator,const Point &pos,RadianAngle dir,float speed);
private:
	Juna::mutual_ptr<XLaser> last;
};


#endif

