

#ifndef Juna_Mutual_Pointer_Hpp
#define Juna_Mutual_Pointer_Hpp

namespace Juna {

class mutual_ptr_pointed
{
protected:
	mutual_ptr_pointed(void) : other(0) {}
	~mutual_ptr_pointed() {unlink();}
	mutual_ptr_pointed *get(void) const {return other;}
	void unlink(void)
	{
		if (other)
		{
			other->other = 0;
			other = 0;
		}
	}
	bool link(mutual_ptr_pointed &other)
	{
		if (get() || other.get())
			return false;
		this->other = &other;
		other.other = this;
		return true;
	}
private:
	mutual_ptr_pointed *other;

	mutual_ptr_pointed(mutual_ptr_pointed &);
	void operator=(mutual_ptr_pointed &);
};

template<class TargetType>
class mutual_ptr : public mutual_ptr_pointed
{
	typedef mutual_ptr_pointed baseClass;
public:
	TargetType *get(void) const {return static_cast<TargetType *>(baseClass::get());}
	void unlink(void) {baseClass::unlink();}
	bool link(TargetType &other) {return baseClass::link(other);}
};

}//	namespace Juna

#endif
